#include <stdlib.h>
#include <gtk/gtk.h>
#include "gtkmdi.h"

static void file_activated (GtkFileChooser *fc, gpointer data);

static GtkWidget *image;

int
main (int argc, char **argv)
{
	GtkWidget *win;
	GtkWidget *swin;
	GtkWidget *mdi;
	GtkWidget *mw;
	GtkWidget *mw2;
	GtkWidget *fc;
	GtkFileFilter *filter;

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	image = gtk_image_new_from_file("/home/patrizio/Documenti/Ducky.jpg");

	win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	g_signal_connect (G_OBJECT (win), "delete-event", gtk_main_quit, NULL);

	mdi = gtk_mdi_new ();
	mw = gtk_mdi_window_new ();
	//gtk_mdi_window_resize (GTK_MDI_WINDOW(mw), 300, 200);
	gtk_mdi_window_set_title (GTK_MDI_WINDOW (mw), "Image");

	mw2 = gtk_mdi_window_new ();
	gtk_mdi_window_resize (GTK_MDI_WINDOW(mw2), 400, 300);
	gtk_mdi_window_set_title (GTK_MDI_WINDOW (mw2), "Choose file");

	gtk_mdi_add_window (GTK_MDI (mdi), GTK_MDI_WINDOW (mw));
	gtk_mdi_add_window (GTK_MDI (mdi), GTK_MDI_WINDOW (mw2));

	swin = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_add (GTK_CONTAINER (swin), mdi);
	gtk_widget_show (swin);
	gtk_container_add (GTK_CONTAINER (win), swin);
	gtk_widget_show (win);

	fc = gtk_file_chooser_widget_new (GTK_FILE_CHOOSER_ACTION_OPEN);
	gtk_widget_set_size_request (fc, 370, 260);
	gtk_container_add (GTK_CONTAINER (mw2), fc);

	filter = gtk_file_filter_new ();
	gtk_file_filter_add_mime_type (filter, "image/png");
	gtk_file_filter_add_mime_type (filter, "image/jpeg");
	gtk_file_filter_add_mime_type (filter, "image/gif");
	gtk_file_filter_add_mime_type (filter, "image/tiff");
	gtk_file_filter_add_mime_type (filter, "image/svg+xml");
	gtk_file_filter_add_mime_type (filter, "image/x-ms-bmp");
	gtk_file_filter_add_mime_type (filter, "image/x-xpixmap");
	gtk_file_filter_add_mime_type (filter, "image/x-xbitmap");

	gtk_file_chooser_set_filter (GTK_FILE_CHOOSER (fc), filter);

	g_signal_connect (fc, "file-activated", file_activated, mw);

	gtk_container_add (GTK_CONTAINER (mw), image);

	gtk_window_set_default_size (GTK_WINDOW (win), 640, 480);

	gtk_widget_show_all (win);

	gtk_mdi_window_move (GTK_MDI_WINDOW (mw), 340, 300);

	gtk_main();

	exit(0);
}

static void
file_activated (GtkFileChooser *fc, gpointer data)
{
	GtkWidget *mw = GTK_WIDGET (data);
	GtkWidget *new_img;

	new_img = gtk_image_new_from_file (gtk_file_chooser_get_filename (fc));
	gtk_widget_destroy (image);
	image = new_img;
	gtk_widget_show (image);
	gtk_container_add (GTK_CONTAINER (mw), image);
}

